const { browser } = require('protractor');

function titulosAPagarPagosPage() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	// const self = this;
	const protractorHelper = require('protractor-helper');

	var EC = protractor.ExpectedConditions;


	this.abrir = () => {
		z.component.menu.open();
		protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
		z.component.menu.clickByPath(['Financeiro', 'Títulos a Pagar', 'Operações', 'Títulos a Pagar/Pagos']);
		geral.esperarLoading();
		geral.clickAplicarFiltro();
	};


	this.lancamento = (unidadeDeOrigem, fornecedor, operacao, serie, valorDocumento, tipoDeConta) => {

		browser.wait(EC.elementToBeClickable($('.popup-container #footer .zh-footer-right a'))).then(function (Acoes) {
			if (Acoes) {

				geral.searchAndClickGridFieldLadZone('NMFILIALRECE', 'NMFILIALRECE', unidadeDeOrigem, 'NMFILIAL');
				geral.searchAndClickGridFieldLadZone('NMRAZSOCFORN', 'NMRAZSOCFORN', fornecedor, 'NMRAZSOCFORN');
				geral.searchAndClickGridFieldLadZone('NMTIPOOPER', 'NMTIPOOPER', operacao, 'NMTIPOOPER');
				geral.searchAndClickGridFieldLadZone('DSSERIE', 'DSSERIE', serie, 'DSSERIEENTR');
				geral.clickAndFllField('VRNOTAFISC', valorDocumento);
				geral.searchAndClickGridField('DSTPCTPAGAR', tipoDeConta, 'DSTPCTPAGAR');
			};
		});
	}


	this.editar = (ajuste, valor) => {
		geral.searchAndClickGridFieldLadZone('DSAJUCTPAG', 'DSAJUCTPAG', ajuste, 'DSAJUCTPAG');
		geral.clickAndFllField('VRAJBOLPAG', valor);
	};


	this.incluir = (vencimento, motivo) => {
		geral.clickAndFllField('DTVENBOLPAG', vencimento, 'DTVENBOLPAG');
		geral.searchAndClickGridFieldLadZone('DSMOTIPROR', 'DSMOTIPROR', motivo, 'DSMOTIPROR');
	};


	this.parcela = (valorLiquido, motivoParcelamento) => {
		geral.clickAndFllField('VRFINALBPAG', valorLiquido);
		geral.searchAndClickGridFieldLadZone('DSMOTIPARC', 'DSMOTIPARC', motivoParcelamento, 'DSMOTIPARC');
	};


	this.parcela1 = (valorLiquido1, motivoParcelamento) => {
		geral.clickAndFllField('VRFINALBPAG', valorLiquido1);
		geral.searchAndClickGridFieldLadZone('DSMOTIPARC', 'DSMOTIPARC', motivoParcelamento, 'DSMOTIPARC');
	};


	this.incluirBaixa = (contaPagamento, tipoDeBaixa) => {
		geral.searchAndClickGridFieldLadZone('DSCONTCORR', 'DSCONTCORR', contaPagamento, 'CDBANCO');
		geral.searchAndClickGridFieldLadZone('NMTPBAIXAPAG', 'NMTPBAIXAPAG', tipoDeBaixa, 'NMTPBAIXAPAG');
	};
}

module.exports = new titulosAPagarPagosPage();
