const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../json/leitorJson.po');
const motivoParcelPage = require('../../../page-objects/parametrizacao/financeiro/motivoParcelamento.po.js');

const motivoParcelGridId = '3410740451533666026236';

describe('Tela Motivo de Parcelamento', () => {
	beforeEach(() => {
		browser.get('http://erpteste.teknisa.com/login/');
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		motivoParcelPage.abrir();
		geral.clickAplicarFiltro();
		protractorHelper.waitForElementVisibility(
			element(by.id(`grid-${motivoParcelGridId}`)), 5000);
	});

	afterEach(() => {
		geral.sair();
	});

	it('Acessar tela Motivo de Parcelamento', () => {
		expect(z.component.header.getTitle()).toBe('Motivo de Parcelamento');
	});

	it('Adicionar uma motivo de parcelamento', () => {
		geral.clickAdicionar();
		motivoParcelPage.adicionar(j.getValor('codigoMotivoParcel'), j.getValor('descricaoMotivoParcel'));
		geral.clickSalvar();
		geral.filterIt(j.getValor('codigoMotivoParcel'));

		expect(geral.gridHasText(motivoParcelGridId, j.getValor('descricaoMotivoParcel'), 1))
			.toBe(j.getValor('descricaoMotivoParcel'));
		expect(geral.gridHasText(motivoParcelGridId, j.getValor('codigoMotivoParcel')))
			.toBe(j.getValor('codigoMotivoParcel'));
	});

	it('Editar registro', () => {
		geral.filterIt(j.getValor('codigoMotivoParcel'));
		geral.clickGrid('DSMOTIPARC', j.getValor('descricaoMotivoParcel'), motivoParcelGridId);
		geral.clickEditar();
		motivoParcelPage.editar(j.getValor('descricaoMotivoParcel1'));
		geral.clickSalvar();
		geral.clickVoltar();
		geral.filterIt(j.getValor('codigoMotivoParcel'));

		expect(geral.gridHasText(motivoParcelGridId, j.getValor('descricaoMotivoParcel1'), 1))
			.toBe(j.getValor('descricaoMotivoParcel1'));
		expect(geral.gridHasText(motivoParcelGridId, j.getValor('codigoMotivoParcel')))
			.toBe(j.getValor('codigoMotivoParcel'));
	});

	it('Excluir registro', () => {
		geral.filterIt(j.getValor('codigoMotivoParcel'));
		geral.clickGrid('DSMOTIPARC', j.getValor('descricaoMotivoParcel1'), motivoParcelGridId);
		geral.clickExcluir();
		geral.clickSim();

		expect(geral.gridHasText(motivoParcelGridId, j.getValor('descricaoMotivoParcel1'), 1))
			.toBeUndefined();
		expect(geral.gridHasText(motivoParcelGridId, j.getValor('codigoMotivoParcel')))
			.toBeUndefined();
	});
});
